#include "gzl_config.h"

uint8_t my_channel_table[NRF_GZLL_DEFAULT_CHANNEL_TABLE_SIZE]={3,30,48,74,89};

bool rc_gzll_set_addr(void)
{
	static bool addrstate = true;
	addrstate &= nrf_gzll_set_base_address_0(NRF_GZLL_DEFAULT_BASE_ADDRESS_0);
//	addrstate &= nrf_gzll_set_base_address_1(NRF_GZLL_DEFAULT_BASE_ADDRESS_1);
	addrstate &= nrf_gzll_set_address_prefix_byte(0,NRF_GZLL_DEFAULT_PREFIX_BYTE_0);
//	addrstate &= nrf_gzll_set_address_prefix_byte(1,NRF_GZLL_DEFAULT_PREFIX_BYTE_1);
//	addrstate &= nrf_gzll_set_address_prefix_byte(2,NRF_GZLL_DEFAULT_PREFIX_BYTE_2);
//	addrstate &= nrf_gzll_set_address_prefix_byte(3,NRF_GZLL_DEFAULT_PREFIX_BYTE_3);
//	addrstate &= nrf_gzll_set_address_prefix_byte(4,NRF_GZLL_DEFAULT_PREFIX_BYTE_4);
//	addrstate &= nrf_gzll_set_address_prefix_byte(5,NRF_GZLL_DEFAULT_PREFIX_BYTE_5);
//	addrstate &= nrf_gzll_set_address_prefix_byte(6,NRF_GZLL_DEFAULT_PREFIX_BYTE_6);
//	addrstate &= nrf_gzll_set_address_prefix_byte(7,NRF_GZLL_DEFAULT_PREFIX_BYTE_7);
	return addrstate;
}
bool rc_gzll_set_freqhop(void)
{
	static bool frehopstate = true;
	frehopstate &= nrf_gzll_set_timeslot_period(GZLL_RX_PEROD/2);
	frehopstate &= nrf_gzll_set_channel_table(my_channel_table,NRF_GZLL_DEFAULT_CHANNEL_TABLE_SIZE);
	frehopstate &= nrf_gzll_set_timeslots_per_channel(timeslots_per_channel);
	#ifdef RCDEVICE
		frehopstate &= nrf_gzll_set_timeslots_per_channel_when_device_out_of_sync(NRF_GZLL_DEFAULT_CHANNEL_TABLE_SIZE*timeslots_per_channel);
		frehopstate &= nrf_gzll_set_device_channel_selection_policy(NRF_GZLL_DEVICE_CHANNEL_SELECTION_POLICY_USE_CURRENT);
	#endif
	return frehopstate;
}

