#include "timer_config.h"

uint16_t ppmdata[11]={0};
uint8_t tempk=0;
static uint16_t tempj = 1;
#ifdef PPMOUTPUT

void timer0_init(void)
{
    // Start 16 MHz crystal oscillator.
    NRF_CLOCK->EVENTS_HFCLKSTARTED  = 0;
    NRF_CLOCK->TASKS_HFCLKSTART     = 1;
    // Wait for the external oscillator to start.
    while (NRF_CLOCK->EVENTS_HFCLKSTARTED == 0) 
    {
			
    }
    NRF_TIMER0->TASKS_CLEAR = 1;
    NRF_TIMER0->PRESCALER = 4;                // Prescaler 4 results in 1 tick equals 1 us
		NRF_TIMER0->CC[3]=PWMCYCLE;
    NRF_TIMER0->MODE      = TIMER_MODE_MODE_Timer;
    NRF_TIMER0->BITMODE   = TIMER_BITMODE_BITMODE_32Bit;	
		NRF_TIMER0->TASKS_START = 1;
    NRF_TIMER0->SHORTS    = (TIMER_SHORTS_COMPARE3_CLEAR_Enabled << TIMER_SHORTS_COMPARE3_CLEAR_Pos);
		NRF_TIMER0->INTENSET = (TIMER_INTENSET_COMPARE0_Enabled << TIMER_INTENSET_COMPARE0_Pos);
		NRF_TIMER0->INTENSET = (TIMER_INTENSET_COMPARE1_Enabled << TIMER_INTENSET_COMPARE1_Pos);
		NRF_TIMER0->INTENSET = (TIMER_INTENSET_COMPARE2_Enabled << TIMER_INTENSET_COMPARE2_Pos);
		NRF_TIMER0->INTENSET = (TIMER_INTENSET_COMPARE3_Enabled << TIMER_INTENSET_COMPARE3_Pos);
}
void timer1_init(void)
{
    NRF_TIMER1->MODE        = TIMER_MODE_MODE_Timer;
    NRF_TIMER1->BITMODE     = TIMER_BITMODE_BITMODE_16Bit << TIMER_BITMODE_BITMODE_Pos;
    NRF_TIMER1->PRESCALER   = 4;

    NRF_TIMER1->TASKS_CLEAR = 1;
		NRF_TIMER1->SHORTS    = (TIMER_SHORTS_COMPARE1_CLEAR_Enabled << TIMER_SHORTS_COMPARE1_CLEAR_Pos);
    NRF_TIMER1->INTENSET = (TIMER_INTENSET_COMPARE0_Enabled << TIMER_INTENSET_COMPARE0_Pos);
	  NRF_TIMER1->INTENSET = (TIMER_INTENSET_COMPARE1_Enabled << TIMER_INTENSET_COMPARE1_Pos);
	  NRF_TIMER1->INTENSET = (TIMER_INTENSET_COMPARE2_Enabled << TIMER_INTENSET_COMPARE2_Pos);
	  NRF_TIMER1->INTENSET = (TIMER_INTENSET_COMPARE3_Enabled << TIMER_INTENSET_COMPARE3_Pos);
    NRF_TIMER1->TASKS_START = 1;
	//	NRF_POWER->TASKS_CONSTLAT = 1;
}
void TIMER0_IRQHandler(void)
{
	if((NRF_TIMER0->EVENTS_COMPARE[3] != 0) && ((NRF_TIMER0->INTENSET & TIMER_INTENSET_COMPARE3_Msk) != 0))
	{
		//printf("Timer0 IRQ\n\r");
		NRF_TIMER0->EVENTS_COMPARE[3] = 0;
		NRF_TIMER0->CC[3] = PWMCYCLE;
		NRF_TIMER1->CC[0] = 480;
		NRF_TIMER1->CC[1] = 1000;
		tempk=0;
		tempj = 0;
		
		if(Lostflag == 1)
		{			
			ppmdata[0] = 1500;
			ppmdata[1] = 1500;
			ppmdata[2] = 1000;	 //		
			ppmdata[3] = 1500;	
			ppmdata[4] = 1500;	
			ppmdata[5] = 1500;
			ppmdata[6] = 1500;	
			ppmdata[7] = 1500;
			ppmdata[8] = 1500;
			ppmdata[9] = 1500;	 //		
			ppmdata[10] = 1500;				
			Lostflag = 1;
		}
		else
		{
			ppmdata[0] = PWMWITH[0];
			ppmdata[1] = PWMWITH[1];
			ppmdata[2] = PWMWITH[2];
			ppmdata[3] = PWMWITH[3];
			ppmdata[4] = PWMWITH[4];	
			ppmdata[5] = PWMWITH[5];
			ppmdata[6] = PWMWITH[6];
			ppmdata[7] = PWMWITH[7];
			ppmdata[8] = PWMWITH[8];
			ppmdata[9] = PWMWITH[9];	
			ppmdata[10] = PWMWITH[9];
		}
		//nrf_gpio_pin_clear(PWMCH1); //ᵼPPMڵһźǰһ 
		NRF_TIMER1->TASKS_CLEAR =1;
		NRF_TIMER0->TASKS_CLEAR =1;
		Lostcount++;
		if(Lostcount > 300)		
		{
			Lostflag=1;
		}
	}
}

void TIMER1_IRQHandler(void)
{

	if(tempk<22)
	{
		if ((NRF_TIMER1->EVENTS_COMPARE[0] != 0) && ((NRF_TIMER1->INTENSET & TIMER_INTENSET_COMPARE0_Msk) != 0))
		{
			NRF_TIMER1->EVENTS_COMPARE[0] = 0;
			nrf_gpio_pin_set(PWMCH1);

		}
		if ((NRF_TIMER1->EVENTS_COMPARE[1] != 0) && ((NRF_TIMER1->INTENSET & TIMER_INTENSET_COMPARE1_Msk) != 0))
		{
			
			NRF_TIMER1->EVENTS_COMPARE[1] = 0;
			nrf_gpio_pin_clear(PWMCH1);	
			NRF_TIMER1->CC[1] = ppmdata[tempj++];				
			if(tempj==20)
				tempj=0;
		}
		tempk++;
	}
}

#else
void timer0_init(void)
{
    // Start 16 MHz crystal oscillator.
    NRF_CLOCK->EVENTS_HFCLKSTARTED  = 0;
    NRF_CLOCK->TASKS_HFCLKSTART     = 1;
    // Wait for the external oscillator to start.
    while (NRF_CLOCK->EVENTS_HFCLKSTARTED == 0) 
    {
			
    }
		
    NRF_TIMER0->TASKS_CLEAR = 1;
    NRF_TIMER0->PRESCALER = 4;                // Prescaler 4 results in 1 tick equals 1 us
		NRF_TIMER0->CC[3]=PWMCYCLE;
    NRF_TIMER0->MODE      = TIMER_MODE_MODE_Timer;
    NRF_TIMER0->BITMODE   = TIMER_BITMODE_BITMODE_32Bit;	
		NRF_TIMER0->TASKS_START = 1;
    NRF_TIMER0->SHORTS    = (TIMER_SHORTS_COMPARE3_CLEAR_Enabled << TIMER_SHORTS_COMPARE3_CLEAR_Pos);
		NRF_TIMER0->INTENSET = (TIMER_INTENSET_COMPARE0_Enabled << TIMER_INTENSET_COMPARE0_Pos);
		NRF_TIMER0->INTENSET = (TIMER_INTENSET_COMPARE1_Enabled << TIMER_INTENSET_COMPARE1_Pos);
		NRF_TIMER0->INTENSET = (TIMER_INTENSET_COMPARE2_Enabled << TIMER_INTENSET_COMPARE2_Pos);
		NRF_TIMER0->INTENSET = (TIMER_INTENSET_COMPARE3_Enabled << TIMER_INTENSET_COMPARE3_Pos);
}
void timer1_init(void)
{
    NRF_TIMER1->MODE        = TIMER_MODE_MODE_Timer;
    NRF_TIMER1->BITMODE     = TIMER_BITMODE_BITMODE_16Bit << TIMER_BITMODE_BITMODE_Pos;
    NRF_TIMER1->PRESCALER   = 4;

    NRF_TIMER1->TASKS_CLEAR = 1;
		//NRF_TIMER1->SHORTS    = (TIMER_SHORTS_COMPARE3_CLEAR_Enabled << TIMER_SHORTS_COMPARE3_CLEAR_Pos);
    NRF_TIMER1->INTENSET = (TIMER_INTENSET_COMPARE0_Enabled << TIMER_INTENSET_COMPARE0_Pos);
	  NRF_TIMER1->INTENSET = (TIMER_INTENSET_COMPARE1_Enabled << TIMER_INTENSET_COMPARE1_Pos);
	  NRF_TIMER1->INTENSET = (TIMER_INTENSET_COMPARE2_Enabled << TIMER_INTENSET_COMPARE2_Pos);
	  NRF_TIMER1->INTENSET = (TIMER_INTENSET_COMPARE3_Enabled << TIMER_INTENSET_COMPARE3_Pos);
    NRF_TIMER1->TASKS_START = 1;
		NRF_POWER->TASKS_CONSTLAT = 1;
}
void TIMER0_IRQHandler(void)
{
	if((NRF_TIMER0->EVENTS_COMPARE[3] != 0) && ((NRF_TIMER0->INTENSET & TIMER_INTENSET_COMPARE3_Msk) != 0))
	{
		//printf("Timer0 IRQ\n\r");
		NRF_TIMER0->EVENTS_COMPARE[3] = 0;
		NRF_TIMER0->CC[3] = PWMCYCLE;
		if(Lostflag == 1)
		{			
			NRF_TIMER0->CC[0] = 1500;
			NRF_TIMER0->CC[1] = 1500;
			NRF_TIMER0->CC[2] = 1000;	 //		
			NRF_TIMER1->CC[0] = 1500;	
			NRF_TIMER1->CC[1] = 1500;	
			NRF_TIMER1->CC[2] = 1500;
			NRF_TIMER1->CC[3] = 1500;				
			Lostflag = 1;
		}
		else
		{
			NRF_TIMER0->CC[0] = PWMWITH[0];
			NRF_TIMER0->CC[1] = PWMWITH[1];
			NRF_TIMER0->CC[2] = PWMWITH[2];
			NRF_TIMER1->CC[0] = PWMWITH[3];
			NRF_TIMER1->CC[1] = PWMWITH[4];	
			NRF_TIMER1->CC[2] = PWMWITH[5];
			NRF_TIMER1->CC[3] = PWMWITH[6];			
		}

		nrf_gpio_port_write(NRF_GPIO_PORT_SELECT_PORT0,0xff); 
		NRF_TIMER1->TASKS_CLEAR =1;
		NRF_TIMER0->TASKS_CLEAR =1;
		Lostcount++;
		if(Lostcount > 300)		
		{
			Lostflag=1;
		}
	}
	if((NRF_TIMER0->EVENTS_COMPARE[0] != 0) && ((NRF_TIMER0->INTENSET & TIMER_INTENSET_COMPARE0_Msk) != 0))
	{
		NRF_TIMER0->EVENTS_COMPARE[0] = 0;
		NRF_TIMER0->CC[0] =0;
		nrf_gpio_pin_clear(PWMCH1);
	}
	if((NRF_TIMER0->EVENTS_COMPARE[1] != 0) && ((NRF_TIMER0->INTENSET & TIMER_INTENSET_COMPARE1_Msk) != 0))
	{
		NRF_TIMER0->EVENTS_COMPARE[1] = 0;
		NRF_TIMER0->CC[1] =0;
		nrf_gpio_pin_clear(PWMCH2);
	}
	if((NRF_TIMER0->EVENTS_COMPARE[2] != 0) && ((NRF_TIMER0->INTENSET & TIMER_INTENSET_COMPARE2_Msk) != 0))
	{
		NRF_TIMER0->EVENTS_COMPARE[2] = 0;
		NRF_TIMER0->CC[2] =0;
		nrf_gpio_pin_clear(PWMCH3);
	}
}
void TIMER1_IRQHandler(void)
{
	if ((NRF_TIMER1->EVENTS_COMPARE[0] != 0) && ((NRF_TIMER1->INTENSET & TIMER_INTENSET_COMPARE0_Msk) != 0))
	{
		NRF_TIMER1->EVENTS_COMPARE[0] = 0;
		NRF_TIMER1->CC[0] =0;
		nrf_gpio_pin_clear(PWMCH4);
	}
	if ((NRF_TIMER1->EVENTS_COMPARE[1] != 0) && ((NRF_TIMER1->INTENSET & TIMER_INTENSET_COMPARE1_Msk) != 0))
	{
		NRF_TIMER1->EVENTS_COMPARE[1] = 0;
		NRF_TIMER1->CC[1] =0;
		nrf_gpio_pin_clear(PWMCH5);
	}
	if ((NRF_TIMER1->EVENTS_COMPARE[2] != 0) && ((NRF_TIMER1->INTENSET & TIMER_INTENSET_COMPARE2_Msk) != 0))
	{
		NRF_TIMER1->EVENTS_COMPARE[2] = 0;
		NRF_TIMER1->CC[2] =0;
		nrf_gpio_pin_clear(PWMCH6);
	}
	if ((NRF_TIMER1->EVENTS_COMPARE[3] != 0) && ((NRF_TIMER1->INTENSET & TIMER_INTENSET_COMPARE3_Msk) != 0))
	{
		NRF_TIMER1->EVENTS_COMPARE[3] = 0;
		NRF_TIMER1->CC[3] =0;
		nrf_gpio_pin_clear(PWMCH7);
	}
}

#endif
