#ifndef TIMER_CONFIG_H__
#define TIMER_CONFIG_H__

#include <stdbool.h>
#include "nrf_gpio.h"

//#define PPMOUTPUT

//PWM Channel output
#define PWMCH1 0
#define PWMCH2 1
#define PWMCH3 2
#define PWMCH4 3
#define PWMCH5 4
#define PWMCH6 5
#define PWMCH7 6
//PWM OUT PARAMETER
#ifdef PPMOUTPUT
	#define PWMCYCLE 22500
#else
	#define PWMCYCLE 10000
#endif

extern uint8_t Lostcount;
extern uint8_t Connectcount;
extern bool Lostflag;
extern bool Connectflag;
extern uint16_t PWMWITH[];

void timer0_init(void);
void timer1_init(void);
void TIMER0_IRQHandler(void);
void TIMER1_IRQHandler(void);


#endif

